; *********************************************************************
; **************		DCF clock		***************
; *********************************************************************
;
; ****************** Navrzeno pro fosc = 3.2768 MHz *******************
;
		list		p=16C84
; *************************
; *** Adresy a promenne ***
; *************************
indf		equ	H'00'
tmr0		equ	H'01'
pcl		equ	H'02'
status		equ	H'03'
c		equ	0
z		equ	2
rp0		equ	5
fsr		equ	H'04'
porta		equ	H'05'
dcf_in		equ	4
portb		equ	H'06'
pclath		equ	H'0A'
intcon		equ	H'0B'
toif		equ	2
toie		equ	5
gie		equ	7
option_reg	equ	H'81'
trisa		equ	H'85'
trisb		equ	H'86'
state		equ	H'0C'
dcf_bit		equ	0
dcf_last	equ	1
control_ok	equ	2
signal_error	equ	3
parity		equ	4
try_parity	equ	5
date_key_last	equ	6
date_key	equ	7
counter		equ	H'0D'
pointer		equ	H'0E'
dcf_time_lo	equ	H'0F'
dcf_time_hi	equ	H'10'
over		equ	3
time_prescaler	equ	H'11'
pre_par_count	equ	H'12'
code_bit	equ	H'13'
code_byte	equ	H'14'
sec		equ	H'15'
min		equ	H'16'
hour		equ	H'17'
day		equ	H'18'
day_name	equ	H'19'
month		equ	H'1A'
year		equ	H'1B'
min_dcf		equ	H'1C'
hour_dcf	equ	H'1D'
day_dcf		equ	H'1E'
day_name_dcf	equ	H'1F'
month_dcf	equ	H'20'
year_dcf	equ	H'21'
min_last	equ	H'22'
hour_last	equ	H'23'
day_last	equ	H'24'
day_name_last	equ	H'25'
month_last	equ	H'26'
year_last	equ	H'27'
digit_1		equ	H'28'
digit_2		equ	H'29'
digit_3		equ	H'2A'
digit_4		equ	H'2B'
digit_5		equ	H'2C'
digit_6		equ	H'2D'
digit_7		equ	H'2E'
digit_8		equ	H'2F'
; *****************
; *** Konstanty ***
; *****************
time_50ms	equ	H'28'
time_150ms	equ	H'78'
time_250ms	equ	H'C8'
; ****************
; *** Adresa 0 ***
; ****************
reset		bcf	status,rp0
		bcf	intcon,gie
		clrf	portb
		goto	start
; ************************************
; *** Adresa 4 - preruseni od tmr0 ***
; ************************************
interrupt	btfss	intcon,toif
		retfie
		bcf	intcon,toif
		btfss	porta,dcf_in	; testuje vstup dcf_in (porta, bit 4)
		goto	dcf_lo
; *******************************************************
; *** dcf_in je hi, nejdrive otestuje zda jiz hi byl: ***
; *** byl - pripocita 1 k dcf_time_lo, pokud pretece, ***
; ***	    skoci na dcf_error			      ***
; *** nebyl - skoci na dcf_change_lo		      ***
; *******************************************************
dcf_hi		btfss	state,dcf_last
		goto	dcf_change_lo
		incfsz	dcf_time_lo,f
		goto	time
		goto	dcf_error
; ********************************************************
; *** dcf_in je lo, nejdrive otestuje, zda jiz lo byl: ***
; *** byl - pricte k dcf_time_lo a dcf_time_low	       ***
; ***	    (druhy rad - pokud pretece prvni rad) 1    ***
; ***	    a pokud je u dcf_time_low bit 3 hi,	       ***
; ***	    nasleduje dcf_error, jinak skoci na time   ***
; *** nebyl - skoci na dcf_change_hi		       ***
; ********************************************************
dcf_lo		btfsc	state,dcf_last
		goto	dcf_change_hi
		incfsz	dcf_time_lo,f
		goto	time
		incf	dcf_time_hi,f
		btfss	dcf_time_hi,over
		goto	time
; ************************************************************
; *** Doslo k prekroceni maximalnich casu na vstupu dcf_in ***
; *** Proto se nastavi signal_error a vynuluje control_ok  ***
; ************************************************************
dcf_error	bsf	state,signal_error
		bcf	state,control_ok
		goto	time
; ************************************************************
; *** Doslo ke zmene na dcf_in z lo na hi, proto se zjisti ***
; *** delka predesleho lo useku				   ***
; *** Pokud byl tento dostatecne dlouhy (dcf_time_hi > 5), ***
; *** probehne dalsi zpracovani dcf informace		   ***
; ************************************************************
dcf_change_lo	bsf	state,dcf_last
		clrf	dcf_time_lo
		movlw	H'05'
		subwf	dcf_time_hi,w
		btfss	status,c
		goto	time
; ************************************************************
; *** Po zjisteni dostatecne delky lo useku se zkontroluje ***
; *** hodnota registru counter (ma byt 59 dec), dale zda   ***
; *** nedoslo k chybe dcf signalu, nastaveni paritniho	   ***
; *** bitu a parita pro datum				   ***
; *** Pokud je vse v poradku pokracuje srovnavanim stare   ***
; *** a nove dcf informace (viz nize), jinak skoci na time ***
; ************************************************************
		bsf	state,control_ok
		movlw	H'3B'
		subwf	counter,f
		btfss	status,z
		bcf	state,control_ok
		clrf	counter
		btfsc	state,signal_error
		bcf	state,control_ok
		bcf	state,signal_error
		btfss	state,parity
		bcf	state,control_ok
		bsf	state,parity
		btfsc	pre_par_count,0
		bcf	state,control_ok
		bcf	pre_par_count,0
		bcf	state,try_parity
		btfss	state,control_ok
		goto	time
; *************************************************************
; *** Pricte 1 minutu ke stare dcf informaci - pro srovnani ***
; *** stare a nove dcf informace			    ***
; *************************************************************
control_dcf	incf	min_last,f
		movf	min_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	compare_dcf
		movf	min_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	min_last
		xorlw	H'60'
		btfss	status,z
		goto	compare_dcf
		clrf	min_last
		incf	hour_last,f
		movf	hour_last,w
		xorlw	H'24'
		btfsc	status,z
		goto	next_day
		movf	hour_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	compare_dcf
		movf	hour_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	hour_last
		goto	compare_dcf
next_day	clrf	hour_last
		incf	day_name_last,f
		movf	day_name_last,w
		xorlw	H'08'
		movlw	H'01'
		btfsc	status,z
		movwf	day_name_last
		incf	day_last,f
		movf	day_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	correct_date
		movf	day_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	day_last
correct_date	movf	month_last,w
		bsf	pclath,0
		bsf	pclath,1
		call	table_of_days
		clrf	pclath
		xorwf	day_last,w
		btfss	status,z
		goto	compare_dcf
		movlw	H'01'
		movwf	day_last
		incf	month_last,f
		movf	month_last,w
		xorlw	H'13'
		btfsc	status,z
		goto	next_year
		movf	month_last,w
		xorlw	H'0A'
		movlw	H'10'
		btfsc	status,z
		movwf	month_last
		goto	compare_dcf
next_year	movlw	H'01'
		movwf	month_last
		incf	year_last,f
		movf	year_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	compare_dcf
		movf	year_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	year_last
		xorlw	H'A0'
		btfss	status,z
		goto	compare_dcf
		clrf	year_last
; ************************************************************
; *** Srovna stary udaj (s prictenou minutou) a novy udaj  ***
; *** a pokud souhlasi, necha nastaveny bit control_ok	   ***
; *** a provede nastaveni casu, reset sekundy a navrat	   ***
; *** Pokud nesouhlasi, pokracuje v normalnim chodu	   ***
; ************************************************************
compare_dcf	movf	min_dcf,w
		xorwf	min_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	min_last
		movf	hour_dcf,w
		xorwf	hour_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	hour_last
		movf	day_name_dcf,w
		xorwf	day_name_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	day_name_last
		movf	day_dcf,w
		xorwf	day_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	day_last
		movf	month_dcf,w
		xorwf	month_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	month_last
		movf	year_dcf,w
		xorwf	year_last,f
		btfss	status,z
		bcf	state,control_ok
		movwf	year_last
		btfss	state,control_ok
		goto	time
		clrf	tmr0
		clrf	time_prescaler
		clrf	pre_par_count
		clrf	sec
		movf	min_dcf,w
		movwf	min
		movf	hour_dcf,w
		movwf	hour
		movf	day_name_dcf,w
		movwf	day_name
		movf	day_dcf,w
		movwf	day
		movf	month_dcf,w
		movwf	month
		movf	year_dcf,w
		movwf	year
		goto	display
; *******************************************************************
; *** Doslo ke zmene na vstupu dcf_in z hi na lo, proto rozkoduje ***
; *** delku dcf impulsu						  ***
; *** Pri delce vetsi nez time_250 ms a mensi nez time_50ms skoci ***
; *** na dcf_error						  ***
; *******************************************************************
dcf_change_hi	bcf	state,dcf_last
		clrf	dcf_time_hi
		movlw	time_50ms
		subwf	dcf_time_lo,w
		btfss	status,c
		goto	dcf_error
		movlw	time_250ms
		subwf	dcf_time_lo,w
		btfsc	status,c
		goto	dcf_error
		bcf	state,dcf_bit
		movlw	time_150ms
		subwf	dcf_time_lo,w
		btfsc	status,c
		bsf	state,dcf_bit
		clrf	dcf_time_lo
; ***********************************************************************
; *** Zapisovani rozkodovaneho dcf_bit do registru casu a bitu parity ***
; ***********************************************************************
		movlw	H'3B'
		subwf	counter,w
		btfsc	status,c
		goto	dcf_error
		movlw	H'15'
		subwf	counter,w
		btfss	status,c
		goto	counter_only
		bsf	pclath,0
		bsf	pclath,1
		call	table_dcf_code
		clrf	pclath
		movwf	code_bit
		movwf	code_byte
		swapf	code_byte,f
		movlw	H'0F'
		andwf	code_bit,f
		andwf	code_byte,w
		btfsc	code_byte,3
		goto	parity_test
		addlw	H'1C'		; offset pro rozkodovani dcf kodu
		movwf	fsr
		movf	code_bit,w
		btfss	state,dcf_bit
		goto	reset_dcf_bit
		addwf	pcl,f
		bsf	indf,0
		goto	control_parity
		bsf	indf,1
		goto	control_parity
		bsf	indf,2
		goto	control_parity
		bsf	indf,3
		goto	control_parity
		bsf	indf,4
		goto	control_parity
		bsf	indf,5
		goto	control_parity
		bsf	indf,6
		goto	control_parity
		bsf	indf,7
		goto	control_parity
reset_dcf_bit	addwf	pcl,f
		bcf	indf,0
		goto	control_parity
		bcf	indf,1
		goto	control_parity
		bcf	indf,2
		goto	control_parity
		bcf	indf,3
		goto	control_parity
		bcf	indf,4
		goto	control_parity
		bcf	indf,5
		goto	control_parity
		bcf	indf,6
		goto	control_parity
		bcf	indf,7				
control_parity	btfss	state,try_parity
		goto	end_of_test
		bcf	state,try_parity
		btfsc	pre_par_count,0
		bcf	state,parity
		bcf	pre_par_count,0
		goto	end_of_test
parity_test	bsf	state,try_parity
end_of_test	btfsc	state,dcf_bit
		incf	pre_par_count,f
		bcf	pre_par_count,1
counter_only	incf	counter,f
; *********************************************************
; *** Zde se pocitaji preruseni a pri kazdem osmistem   ***
; *** se pricte 1 sekunda k casu v registrech a zobrazi ***
; *** se casova informace,jinak se zjisti stav tlacitek	***
; *********************************************************
time		incfsz	time_prescaler,f
		goto	continue
		movlw	H'10'
		addwf	pre_par_count,f
		goto	which_key
continue	movlw	H'30'
		subwf	pre_par_count,w
		btfss	status,c
		goto	which_key
		movlw	H'20'
		subwf	time_prescaler,w
		btfss	status,z
		goto	which_key
		clrf	time_prescaler
		movlw	H'0F'
		andwf	pre_par_count,f
; *****************************************
; *** Pricte sekundu a ohlida preteceni ***
; *** jednotlivych registru casu	***
; *****************************************
plus_second	incf	sec,f
		movf	sec,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	display
		movf	sec,w
		andlw	H'F0'
		addlw	H'10'
		movwf	sec
		xorlw	H'60'
		btfss	status,z
		goto	display
		clrf	sec
		incf	min,f
		movf	min,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	display
		movf	min,w
		andlw	H'F0'
		addlw	H'10'
		movwf	min
		xorlw	H'60'
		btfss	status,z
		goto	display
		clrf	min
		incf	hour,f
		movf	hour,w
		xorlw	H'24'
		btfsc	status,z
		goto	new_day
		movf	hour,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	display
		movf	hour,w
		andlw	H'F0'
		addlw	H'10'
		movwf	hour
		goto	display
new_day		clrf	hour
		incf	day_name,f
		movf	day_name,w
		xorlw	H'08'
		movlw	H'01'
		btfsc	status,z
		movwf	day_name
		incf	day,f
		movf	day,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	correction
		movf	day,w
		andlw	H'F0'
		addlw	H'10'
		movwf	day
correction	movf	month,w
		bsf	pclath,0
		bsf	pclath,1
		call	table_of_days
		clrf	pclath
		xorwf	day,w
		btfss	status,z
		goto	display
		movlw	H'01'
		movwf	day
		incf	month,f
		movf	month,w
		xorlw	H'13'
		btfsc	status,z
		goto	new_year
		movf	month,w
		xorlw	H'0A'
		movlw	H'10'
		btfsc	status,z
		movwf	month
		goto	display
new_year	movlw	H'01'
		movwf	month
		incf	year,f
		movf	year,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	status,z
		goto	display
		movf	year,w
		andlw	H'F0'
		addlw	H'10'
		movwf	year
		xorlw	H'A0'
		btfss	status,z
		goto	display
		clrf	year
		goto	display
; ***************************************************************
; *** Otestuje tlacitka a pokud je nektere zmacknute, nastavi ***
; *** odpovidajici bit pro zobrazeni prislusnych udaju	      ***
; ***************************************************************
which_key	movlw	H'04'
		xorwf	pointer,w
		btfss	status,z
		goto	out_of_pic
		btfss	porta,3
		goto	key_input_lo
		btfsc	state,date_key_last
		goto	out_of_pic
		bsf	state,date_key_last
		movlw	H'80'
		addwf	state,f
		goto	display
key_input_lo	bcf	state,date_key_last
		goto	out_of_pic
; *************************************************************
; *** Zjisti, co se zobrazuje a dle toho ulozi odpovidajici ***
; *** informaci do registru zobrazeni			    ***
; *************************************************************
display		bsf	pclath,0
		bsf	pclath,1
		btfsc	state,date_key
		goto	date_read
clock_read	movf	sec,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_8
		swapf	sec,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_7
		clrf	digit_6
		movf	min,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_5
		swapf	min,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_4
		clrf	digit_3
		movlw	H'12'
		call	table_of_signs
		btfsc	state,control_ok
		movwf	digit_3
		movf	hour,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_2
		clrf	digit_1
		swapf	hour,w
		andlw	H'0F'
		btfsc	status,z
		goto	end_of_display
		call	table_of_signs
		movwf	digit_1
		goto	end_of_display
date_read	movf	year,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_8
		swapf	year,w
		andlw	H'0F'
		call	table_of_signs
		movwf	digit_7
		movf	month,w
		andlw	H'0F'
		call	table_of_signs
		iorlw	H'01'
		movwf	digit_6
		swapf	month,w
		andlw	H'0F'
		btfsc	status,z
		goto	d_4
		call	table_of_signs
		movwf	digit_5
		movf	day,w
		andlw	H'0F'
		call	table_of_signs
		iorlw	H'01'
		movwf	digit_4
		clrf	digit_3
		swapf	day,w
		andlw	H'0F'
		btfsc	status,z
		goto	d_2
		call	table_of_signs
		movwf	digit_3
		goto	d_2
d_4		clrf	digit_3
		movf	day,w
		andlw	H'0F'
		call	table_of_signs
		iorlw	H'01'
		movwf	digit_5
		clrf	digit_4
		swapf	day,w
		andlw	H'0F'
		btfsc	status,z
		goto	d_2
		call	table_of_signs
		movwf	digit_4
d_2		movf	day_name,w
		call	decode_day_2
		call	table_of_signs
		movwf	digit_2
		movf	day_name,w
		call	decode_day_1
		call	table_of_signs
		movwf	digit_1
end_of_display	clrf	pclath
; **************************************************
; *** Zobrazi registry casu na ktere se odvolava ***
; *** predchozi pricitani sekundy a DCF dekoder	 ***
; **************************************************
out_of_pic	movf	pointer,w
		sublw	H'30'
		movwf	fsr
		clrf	portb
		decf	pointer,w
		movwf	porta
		movf	indf,w
		movwf	portb
		decfsz	pointer,f
		retfie
		movlw	H'08'
		movwf	pointer
		retfie
; *************************************************************
; *** Zde zacina program, probehne reset udaju pri spusteni ***
; *************************************************************
start		movlw	H'0C'
		movwf	fsr
loop		clrf	indf
		incf	fsr,f
		movf	fsr,w
		xorlw	H'30'
		btfss	status,z
		goto	loop
		bsf	state,signal_error
		movlw	H'08'
		movwf	pointer
		bsf	status,rp0
		movlw	H'C1'
		movwf	option_reg
		movlw	H'18'
		movwf	trisa
		clrf	trisb
		bcf	status,rp0
		clrf	tmr0
		movlw	H'01'
		movwf	day
		movwf	day_name
		movwf	month
		movlw	b'01111010'
		movwf	digit_1
		movlw	b'01100010'
		movwf	digit_2
		movlw	b'11000110'
		movwf	digit_3
		movlw	b'10011100'
		movwf	digit_6
		movlw	b'10011101'
		movwf	digit_7
		movlw	b'10110110'
		movwf	digit_8
		bcf	intcon,toif
		bsf	intcon,toie
		bsf	intcon,gie
; *********************************************
; *** Zde program ceka na preruseni od tmr0 ***
; *********************************************
begin		nop
		goto	begin
;
;
;
; ***********************************************************
; *** Zde zacinaji tabulky umistene do 3 pametove oblasti ***
; ***********************************************************
		org	H'0300'
; ***********************************************
; *** Tabulka poctu dnu pro jednotlive mesice ***
; ***********************************************
table_of_days	addwf	pcl,f
		retlw	H'00'
		retlw	H'32'
		retlw	H'29'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
; ******************************************************
; *** Tabulka polohy bitu dcf_bit v casove informaci ***
; ******************************************************
table_dcf_code	addwf	pcl,f
		retlw	H'00'
		retlw	H'02'
		retlw	H'04'
		retlw	H'06'
		retlw	H'08'
		retlw	H'0A'
		retlw	H'0C'
		retlw	H'80'
		retlw	H'10'
		retlw	H'12'
		retlw	H'14'
		retlw	H'16'
		retlw	H'18'
		retlw	H'1A'
		retlw	H'80'
		retlw	H'20'
		retlw	H'22'
		retlw	H'24'
		retlw	H'26'
		retlw	H'28'
		retlw	H'2A'
		retlw	H'30'
		retlw	H'32'
		retlw	H'34'
		retlw	H'40'
		retlw	H'42'
		retlw	H'44'
		retlw	H'46'
		retlw	H'48'
		retlw	H'50'
		retlw	H'52'
		retlw	H'54'
		retlw	H'56'
		retlw	H'58'
		retlw	H'5A'
		retlw	H'5C'
		retlw	H'5E'
		retlw	H'80'
; ***************************************************************
; *** Tabulka kodu znaku pro jednotlive segmenty LED displaye ***
; ***************************************************************
table_of_signs	addwf	pcl,f
		retlw	B'11111100'	; 0
		retlw	B'00011000'	; 1
		retlw	B'01101110'	; 2
		retlw	B'00111110'	; 3
		retlw	B'10011010'	; 4
		retlw	B'10110110'	; 5
		retlw	B'11110110'	; 6
		retlw	B'10011100'	; 7
		retlw	B'11111110'	; 8
		retlw	B'10111110'	; 9
		retlw	B'11011110'	; A
		retlw	B'11100100'	; C
		retlw	B'11100110'	; E
		retlw	B'11001110'	; P
		retlw	B'01010010'	; n
		retlw	B'01110010'	; o
		retlw	B'11100010'	; t
		retlw	B'11111000'	; U
		retlw	B'00000010'	; -
		retlw	B'11100000'	; L
; *********************************
; *** Tabulka prvniho znaku dne ***
; *********************************
decode_day_1	addwf	pcl,f
		retlw	H'0C'
		retlw	H'0D'
		retlw	H'11'
		retlw	H'05'
		retlw	H'0B'
		retlw	H'0D'
		retlw	H'05'
		retlw	H'0E'
; *********************************
; *** Tabulka druheho znaku dne ***
; *********************************
decode_day_2	addwf	pcl,f
		retlw	H'0C'
		retlw	H'0F'
		retlw	H'10'
		retlw	H'10'
		retlw	H'10'
		retlw	H'0A'
		retlw	H'0F'
		retlw	H'0C'
		end